#include "string"
#include "legsplit.h"


class Corrector
{
  private :
    LegSplitN stretch_pol;
  LegSplitN color_pol;
  
  public :
    
    Corrector(int dimension_i, int* degrees_i, 
	      double* XMin, double* XMax, double X1Cut); 
  
  Corrector(const LegSplitN &stretch_pol_in,const LegSplitN &color_pol_in);
  Corrector(const std::string &FileSuffix);
  Corrector(const std::string &FileName_stretch,const std::string &FileName_color);
  
  bool Write(const std::string &FileSuffix) const;
  const LegSplitN& FirstPol() const {return stretch_pol;};
  const LegSplitN& SecondPol() const {return color_pol;};
  double Value(const double *X) const;
  Corrector operator +(const Corrector& Right) const;
  void operator +=(const Corrector& Right);
  int CoeffSize() const;
  void Monomials(const double* X, double *Monom) const;
  void DMonomialsDXN(int N, const double* X, double * DMonomDxN) const;
  int GetDegree(int d) const;
  int Dimension() const {return 4;};
  bool IsValidValue(int d,double val) const;
  void SetCoeffs(const double *Val);
  
};


