#include "filter.h"


#include <fstream>
using namespace std;
#include <math.h>

#include "snfitexception.h"


ostream& operator << (ostream &stream, const Filter &This)
{
  stream << This.Name() << ':'; This.General1DFunction::dump(stream);
  return stream;
}


double Filter::CentralWaveLength() const
{
  return(Mean());
}


bool Filter::Write(const std::string &FileName) const
{
  ofstream s(FileName.c_str());
  if (!s)
    throw(SnfitException("  Filter::Write : could not open "+FileName));

  // globs
  vector<string> globs = glob.OutputLines();
  for (size_t k = 0; k < globs.size(); ++k)
    s << '@' << globs[k] << endl;
  // header (optional... actually)
  s << "# lambda : Angstroms " << endl;
  s << "# tr : transmission ([0,1]) " << endl;
  s << "# end" << endl;
  // data
  General1DFunction::Write(s);
  return true;
}
  
string InstrumentNameFromFilterName(const std::string &InstFilterName)
{
  size_t pos = InstFilterName.find("::");
  if (pos == string::npos) throw(SnfitException(" cannot decode an instrument::filter in "+InstFilterName));
  return InstFilterName.substr(0,pos);
}
