// -*- C++ -*-
// 
// \file globalval.h
// 
// Last modified: $Date: 2009-02-24 09:52:33 $
// By:            $Author: astier $
// 

#ifndef GLOBALVAL__H
#define GLOBALVAL__H


#include <string>
#include <list>
#include <vector>
#include <map>
#include <iostream>

using namespace std;

//! to store in files things like "Key value(s)" things.
class GlobalVal : private  map<string, vector<string> > {
public :

  GlobalVal() {};

  bool AddKey(const string &Key, const vector<string> &Values);
  
  bool AddKey(const string &Key, const string &Value);
  
  bool AddKey(const string& Key, const list<string>& Values);
  
  bool AddKey(const string &Key, const vector<double> &Values);
  
  bool AddKey(const string &Key, const double &Value);

  bool AddKey(const string& Key, const list<double>& Values);
  
  size_t NKey() const;

  bool HasKey(const string &Key) const;
  
  string         getStringValue(const string& Key) const;
  
  vector<string> getStringValues(const string& Key) const;
  
  double         getDoubleValue(const string& Key) const;
  
  vector<double> getDoubleValues(const string& Key) const;

  vector<string> OutputLines() const;

  bool ProcessLine(char *Line);

  // this constructor is to be used when you only need to read '@' lines in a file
  GlobalVal(const std::string &FileName);

  //  GlobalVal(const GlobalVal &O) { cout << " on copie un globalval " << endl;}


private:
  template<typename T>
  bool GenericAddKey(const string& Key, const T& Values);
};

std::ostream& operator <<(ostream &S, const GlobalVal &G);

#endif /* GLOBALVAL__H */
