#ifndef HUBBLEFLUXMODEL_H
#define HUBBLEFLUXMODEL_H

#include "hubblemodel.h"
#include "fittedsn.h"
#include "param.h"

#define PD_NMAX 100
class HubbleFluxModel : public HubbleModel {

 private:
  int pd_n;
  float pd_x[PD_NMAX];
  float pd_a[PD_NMAX];
  float pd_b[PD_NMAX];
  float pd_c[PD_NMAX];
 
 public:

  HubbleFluxModel();
  ~HubbleFluxModel() {};
  double Bias(FittedSn* sn);
  double ErrorFlux(FittedSn* sn);
  double ErrorMag(FittedSn* sn);
  
  double FluxModel(FittedSn* sn, bool for_errors=false);
  virtual double Chi2(FittedSn* sn);
  virtual double Res(FittedSn* sn);
  virtual double Weight(FittedSn* sn); 
};


#endif /*  HUBBLEFLUXMODEL__H */
