#ifndef HUBBLEMAGMODEL_H
#define HUBBLEMAGMODEL_H

#include "hubblemodel.h"
#include "fittedsn.h"
#include "param.h"


class HubbleMagModel : public HubbleModel {

 private:
  LcParam **Mprime;
  LcParam **alpha;
  LcParam **beta;
  
  

 public:

  HubbleMagModel(int n);
  ~HubbleMagModel() {if (Mprime) delete [] Mprime ; if (alpha) delete [] alpha ; if (beta) delete [] beta ;  };
  
  virtual double Mag(const FittedSn* sn) const;
  virtual double Mprime_(const FittedSn* sn) const;
  virtual double Res(const FittedSn* sn) const;
  virtual double Variance(const FittedSn* sn) const;
  virtual void InitParams(); 
};


#endif /*  HUBBLEMAGMODEL__H */
