#ifndef HUBBLEMAGMODEL2_H
#define HUBBLEMAGMODEL2_H

#include "hubblemodel.h"
#include "fittedsn.h"
#include "param.h"

//#define DALPHABETADZ

class HubbleMagModel2 : public HubbleModel {
 private:
  LcParam **Mprime;
  LcParam **alpha;
  LcParam **beta;
  

#ifdef DALPHABETADZ
  LcParam **d_alpha_dz;
  LcParam **d_beta_dz;
#endif

#ifdef WITH_UV_FIT
  LcParam *beta_uv;
#endif  
  
#ifdef WITH_HOST_EXTINCTION  
  LcParam *Rb;
#endif

  
  
  int number_of_salt2_components;

  
 public:

#ifdef WITH_UV_FIT
  bool has_uv_fit;
#endif
#ifdef WITH_HOST_EXTINCTION 
  bool has_cardelli_extinction;
#endif
  HubbleMagModel2(int input_number_of_galaxy_types);
  
  ~HubbleMagModel2() {if (Mprime) delete [] Mprime ; if (alpha) delete [] alpha ; if (beta) delete [] beta ;};
  
  virtual double Mag(const FittedSn* sn) const;
  virtual double Mprime_(const FittedSn* sn) const;
  virtual double Res(const FittedSn* sn) const;
  virtual double Variance(const FittedSn* sn) const;
  virtual void InitParams();
  int NumberOfSALT2Components() const {return number_of_salt2_components;};
  void SetNumberOfSALT2Components(int n)  {number_of_salt2_components=n;};
};


#endif /*  HUBBLEMAGMODEL2__H */
