#ifndef INTEGFLUX__H
#define INTEGFLUX__H

class Sampled1DFunction;
class General1DFunction;

double IntegFlux(const Sampled1DFunction &Spectrum,
		 const Sampled1DFunction &ObserverFilter, 
		 const double &z, bool do_check_range=true);

double IntegFlux(const Sampled1DFunction &Spectrum, 
		 const Sampled1DFunction &ObserverFilter, 
		 const Sampled1DFunction &RestframeFilter,
		 const double &z, bool do_check_range=true);


// each entry in the General1DFunction is treated as an emission line
double SumLines(const General1DFunction &Spectrum,
		const Sampled1DFunction &ObserverFilter,
		const double &z);

// each entry in the General1DFunction is treated as an emission line
double SumLines(const General1DFunction &Spectrum,
		const Sampled1DFunction &ObserverFilter,
		const Sampled1DFunction &RestframeFilter,
		const double &z);




#endif /* INTEGFLUX__H */
