#ifndef MAGSYS__H
#define MAGSYS__H

#include <string>
#include <map>

using namespace std;

class Sampled1DFunction;
class General1DFunction;
class Filter;

class MagSys 
{
 private :
  std::string name, fileName;
  Sampled1DFunction *spectrum; // the ref spectrum 
  map<string,double> mags;
  General1DFunction *offsetFunction;

 public :
  MagSys(const string &SysName);

  double Mag(const  Sampled1DFunction& ObjSpectrum,
	     const Filter &ObserverFilter,
	     const double &z, bool do_check_range=true) const;

  double Mag(const Sampled1DFunction& ObjSpectrum,
	     const Filter &ObserverFilter,
	     const Sampled1DFunction &RestframeFilter,
	     const double &z, bool do_check_range=true) const;

  double ZeroPoint(const Filter & ObserverFilter) const;


  ~MagSys();


};


const MagSys* GetMagSys(const string &Name);


#endif /* MAGSYS__H */
