#include <iostream>
#include "pathutils.h"
#include "fileutils.h"
#include "datacards.h"

using namespace std;

string AssembleFileName(const string &DirName, const string &FileName,
			const bool Warn)
{
  ///// if (FileExists(FileName)) return FileName;
  string tmp = AddSlash(DirName);
  string s1 = tmp+FileName;
  if (FileExists(s1)) { 
    return s1;
  }
  string s2 = tmp+BaseName(FileName);
  if (Warn && !FileExists(s2))
    {
      cerr << " cannot find '" << FileName << "' nor '" << s1 << "' nor '" << s2 << "'" << endl;
      cerr <<" expect troubles" << endl;
    }
  return s2;
}


string LocateFile(const string &FileName)
{
  static char *pathlc = NULL;
  if (!pathlc) pathlc = getenv("PATHMODEL");
  if (!pathlc)
    {
      std::cerr << " you should setenv PATHMODEL to the location of calib files" 
		<< std::endl;
      abort();
      return "";
    }
  return AssembleFileName(pathlc,FileName);
}

string LocateFileFromCard(const string &Key)
{
  char *pathlc = getenv("PATHMODEL");
  if (!pathlc)
    {
      std::cerr << " you should setenv PATHMODEL to the location of calib files" 
		<< std::endl;
      abort();
      return "";
    }
  string mainfile = string(pathlc)+"/fitmodel.card";
  DataCards cards(mainfile);
  if(! cards.HasKey(Key))
    std::cerr << " cannot find key " << Key << " in main file " << mainfile << endl;
  else
    {
      string FileName = cards.SParam(Key);
#ifdef DEBUG
      cout << "LocateFileFromCard: " << Key << " -> " << FileName << endl;
#endif
      return AssembleFileName(pathlc,FileName);
    }
  return AssembleFileName(pathlc,Key);
}



