#include "spectra.h"
#include "sampledfunction.h"
#include "sstream"
#include <stdio.h>
#include "pathutils.h"
#include "snfitexception.h"


#include <cstdlib>
#include <cstring>

ListOfSpectra::ListOfSpectra(const string &FileName)
{
  currentgroup=-1;
  Add(FileName);
}

void ListOfSpectra::Add(const string &FileName)
{
  currentgroup++;
  FILE *f = fopen(FileName.c_str(),"r");
  if (!f) 
    {
      throw(SnfitException(" ListOfSpectra : cannot find "+FileName));
      return;
    }
  char line[1024];
  //cout << " reading filters from : " << FileName << endl;
  string path = getenv("PATHMODEL");
  while (fgets(line,1024,f))
    {
      char *p = line + strspn(line," \t");
      if (strlen(p) == 0) continue;
      if (p[0] == '#') continue;
      char filename[128];

      if (sscanf(line,"%s", filename) == 1)
	{
	  /*
	    cout << " reading " << tag  << " (" << name << ") " 
	    << filename << endl;
	  */
	  
	  string Completename  =  path + filename;
	  push_back(Spectra(Completename,currentgroup));	  
	}
      else 
	{
	  cerr << " cannot decode : " << p << " in " << FileName << endl;
	  continue;
	}
    }
}


