#ifndef SPECTRUMTEMPLATE__H
#define SPECTRUMTEMPLATE__H


#include <string>
#include <map>

#include "param.h"
#include "model2fit.h"
#include "templatecurves.h"
#include "sampledfunction.h"
#include "measureddata.h"



class SpectrumTemplate : public Model2Fit 
{
  private :
    //TemplateCurves templateCurves; 
    SnSpectra *templateSpectrum;
  FilterWheel bands;
  //string &bandname;
  map<const string,BandParams*> Params4Band; // map of parameters for one fitted band, internal storage  
  map<const Filter*,string> BandOfFit4ObserverFilter; // map of associations between ObserverFilter and fitted bands
  map<const Filter*,BandParams*> Params4ObserverFilter; // shortcut to go faster in the fit
  int LoadModel(const string &modelFileName); //load the model

  
  public :

  void CreateNeededParams(const MeasuredData* data);
  void ReadParams(const string& filename,bool createifmissing = true);
  bool CanComputeFluxFor(const Filter &observerfilter) const;
  
  // dynamic association of ObserverFilters to parameters
  BandParams* GetParams4ObserverFilter(const Filter* filter, bool computeifnecessary=true);

  SpectrumTemplate();
  SpectrumTemplate(const string &ModelFileName);

  const SnSpectra& TempSpectrum() const {return *templateSpectrum;}
  double Flux(const Filter* filter,
	      const double observerday);
  void InitParams(const MeasuredData* data);
  string ModelName() const {return "SpectrumTemplate";};
  const FilterWheel& Bands() const { return bands;}
};


#endif /* MODEL2FIT__H */
