#ifndef WMAP5COSMOPRIOR__H
#define WMAP5COSMOPRIOR__H

#include "cosmology_prior.h"

class Cosmology;
class Wmap5Cosmo;

class Vect;
class Mat;


class Wmap5CosmoPrior : public Prior  /* impossible ?? */ 
{
public :
  Wmap5CosmoPrior() {name = "WMAP5";}
  double Chi2(const Cosmology *Cosmo, Vect* output_residuals) const; // Cosmo must be a OmegamW0Cosmo
  double Chi2(const Cosmology *Cosmo) const {return Chi2(Cosmo,0);}; // Cosmo must be a OmegamW0Cosmo
  Vect Residual(const Cosmology *Cosmo) const; // Cosmo must be a OmegamW0Cosmo
  Mat Weight(const Cosmology *Cosmo=0) const; 
  

 private:
  double Chi2ForWmap5Cosmo(const Wmap5Cosmo *Cosmo) const;
  Vect ResidualForWmap5Cosmo(const Wmap5Cosmo *Cosmo) const;
  
  
};



#endif
